import os
from cStringIO import StringIO
from Products.CMFCore.utils import getToolByName
from os.path import isdir, join
from Globals import package_home
from Products.CMFCore.utils import minimalpath
from Products.CMFCore.DirectoryView import manage_listAvailableDirectories
from Products.CMFCore.DirectoryView import registerDirectory
from Products.CMFCore.DirectoryView import addDirectoryViews
import string

from Products.Archetypes import listTypes
from Products.Archetypes.Extensions.utils import installTypes, install_subskin

from Products.SevenVideo.config import PROJECTNAME, GLOBALS, SKINS_DIR, SKINNAME

skinname = SKINNAME
baseSkin = 'Plone Default'

def install_skins(self, out, globals=GLOBALS, product_skins_dir=SKINS_DIR):

    out.write('%s Installation on %s\n' %(PROJECTNAME, self.id))
    out.write('======================\n\n')

    skinstool=getToolByName(self, 'portal_skins')

    fullProductSkinsPath = join(package_home(globals), product_skins_dir)
    productSkinsPath = minimalpath(fullProductSkinsPath)
    registered_directories = manage_listAvailableDirectories()

    if productSkinsPath+'/sevenvideo' not in registered_directories:
        registerDirectory(product_skins_dir+'/sevenvideo', globals)
    try:
        addDirectoryViews(skinstool, product_skins_dir, globals)
        out.write("Added %s directory view to portal_skins\n" % skinname)
    except BadRequestException, e:
       pass  # directory view has already been added
       out.write("%s directory view already existed in portal_skins\n" % skinname)

    # Insert 'cart' into the skin configurations.
    files = os.listdir(fullProductSkinsPath)
    for productSkinName in files:
        if (isdir(join(fullProductSkinsPath, productSkinName))
            and productSkinName != 'themes'
            and productSkinName != 'CVS'
            and productSkinName != '.svn'):
            for skinName in skinstool.getSkinSelections():
                path = skinstool.getSkinPath(skinName)
                path = [i.strip() for i in  path.split(',')]
                try:
                    if productSkinName not in path:
                        path.insert(path.index('custom') +1, productSkinName)
                except ValueError:
                    if productSkinName not in path:
                        path.append(productSkinName)
                path = ','.join(path)

                # addSkinSelection will replace existing skins as well.
                skinstool.addSkinSelection(skinName, path)
                out.write("Added %s to %s skin\n" % (skinname, skinName))

    path = [p.strip() for p in skinstool.getSkinPath('Plone Default').split(',')]
    path.remove('custom')

def removeSkin(self, out):

    portal_skins = getToolByName(self, 'portal_skins')
    skins = portal_skins.getSkinSelections()
    for skin in skins:
        path = portal_skins.getSkinPath(skin)
        path = map(string.strip, string.split(path,','))
        if skinname in path:
            path.remove(skinname)
            path = string.join(path, ', ')
            portal_skins.addSkinSelection(skin, path)

    if skinname in portal_skins.objectIds():
        portal_skins._delObject(skinname)
        out.write('Removed %s from the portal_skins\n' % skinname)

def install(self):
    out = StringIO()

    install_skins(self, out)

    classes = listTypes(PROJECTNAME)
    installTypes(self, out, classes, PROJECTNAME)
    install_subskin(self, out, GLOBALS)

    out.write ('Successfully installed %s.\n' % PROJECTNAME)

    return out.getvalue()


def uninstall (self):
    out = StringIO ()

    removeSkin(self, out)
    out.write ('Uninstallation completed.\n')
    return out.getvalue()

