from Products.CMFCore.utils import ContentInit

from Products.Archetypes.public import listTypes
from Products.Archetypes.public import process_types
from Products.CMFCore.DirectoryView import registerDirectory

from Products.SevenVideo import config
from Products.SevenVideo.permissions import ADD_DEFAULT
from Products.SevenVideo.permissions import ADD_PERMISSIONS

registerDirectory(config.SKINS_DIR, config.GLOBALS)

def initialize(context):

    import content

    content_types, constructors, ftis = process_types(
        listTypes(config.PROJECTNAME), config.PROJECTNAME)

    all_types = zip(content_types, constructors)
    for atype, constructor in all_types:
        kind = '%s: %s' % (config.PROJECTNAME, atype.archetype_name)
        ContentInit(
            kind,
            content_types = (atype,),
            permission = ADD_PERMISSIONS.get(atype.portal_type, ADD_DEFAULT),
            extra_constructors = (constructor,),
            fti = ftis,
        ).initialize(context)
