from zLOG import LOG, INFO

LOG('SevenVideo',INFO, 'Installing Product')

from Products.CMFCore.CMFCorePermissions import View
from AccessControl import ClassSecurityInfo

from Products.Archetypes.public import *
from Products.Archetypes.Marshall import RFC822Marshaller
from Products.SevenVideo import config
from Products.Archetypes.interfaces.vocabulary import IVocabulary


def modify_fti(fti):
    for a in fti['actions']:
        if a['id'] in ('references',):
            a['visible'] = 0
    return fti


schema = BaseSchema +  Schema((

    StringField('title',
        required=1,
        searchable=1,
        accessor='Title',
        widget=StringWidget(
            label='Movie name',
            description='Title of the item',
        ),
    ),

    TextField('description',
        required=0,
        searchable=1,
        widget=TextAreaWidget(
            label='Movie description',
            description='A description of Movie.',
      ),
    ),

    StringField('url',
        required=1,
        searchable=1,
        widget=StringWidget(
            label='Movie Url',
            description='Movie url of the item',
        ),
        default = "http://",
    ),

   StringField('local',
        vocabulary='viewLocal',
        enforceVocabulary=True,
        widget=SelectionWidget(
            format='select',
            label='Which the local?',
            visible={'view': 'invisible', 'edit': 'visible'},
        ),
        required=1,
    ),

   ),marshall=RFC822Marshaller(),
  )

class MovieItem(BaseContent):

    schema = schema
    meta_type = portal_type = archetype_name = 'Movie' 
    allowed_content_types = []
    _at_rename_after_creation = True
    immediate_view = 'movie_view'
    default_view   = 'movie_view'
    typeDescription = 'A product description.'

    actions = ({
        'id': 'view',
        'name': 'View',
        'action': 'string:${object_url}/movie_view',
        'permissions': (View,)
        },
)

    content_icon = "movie.gif"

    def viewLocal(self):
        results = ['youtube','metacafe']
        return results

registerType(MovieItem, config.PROJECTNAME)
